#!/bin/env dls-python
import PandATest
from collections import OrderedDict

class Fmc(PandATest.PandATest):

    def test_code(self):

        #(cmd, (expected result, +/- bound of result))
        internal_commands = OrderedDict([
            ('FMC.FMC_PRSNT?',      ('OK =1',       0)),
            ('FMC.LOOP_PERIOD=125', ('OK',          0)),
            ('FMC.SOFT_RESET=',     ('OK',          0)),
            ('FMC.LA_P_ERROR?',     ('OK =0',       0)),
            ('FMC.LA_N_ERROR?',     ('OK =0',       0)),
            ('FMC.GTREFCLK?',       ('OK =10240',   1)),
            ('FMC.FMC_CLK0?',       ('OK =10240',   1)),
            ('FMC.FMC_CLK1?',       ('OK =10240',   1)),
            ('FMC.LINK_UP?',        ('OK =1',       0)),
        ])

        external_commands = OrderedDict([
            ('FMC.EXT_CLK?',       ('OK =0',        1)),
        ])

        for cmd, expected in internal_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))

        inputy = '.'
        while inputy != '':
            print "External clock connected ? [return]"
            inputy = raw_input()

        while True:
            print 'What is the external clock frequency (MHz) ?'
            try:
                custom_freq = int(raw_input())
                self.logger.info(
                    "{:<21}{}".format("EXTERN CLCK FREQ MHz", custom_freq))
                break
            except ValueError:
                pass

        for cmd, expected in external_commands.items():
            response = self.send_cmd(cmd)
            expected = 'OK =' + str(((8192 * 8) * custom_freq))
            self.test_result.append(
                self.check_response(response, expected, cmd, 1))

        return not all(self.test_result)

    def check_response(self, response, expected, cmd, bnd=0):
        try:
            response_val = int(response.split('=')[1])
            expected_val = int(expected.split('=')[1])
            check = expected_val - bnd <= response_val <= expected_val + bnd
        except IndexError:
            check = response == expected

        if check:
            self.logger.info("{:<20} [{:<9}]  ..OK".format(cmd, response))
            return 1
        else:
            self.logger.info("{:<20} [{:<9}]  ..NOT OK".format(cmd, response))
            return 0