#!/bin/env dls-python
import PandATest
from collections import OrderedDict


class Sfp(PandATest.PandATest):

    def test_code(self):
        #(cmd, (expected result, +- bound of result))
        internal_commands = OrderedDict([
            ('SFP.SOFT_RESET=',     ('OK', 0)),
            ('SFP.SFP_CLK1?',       ('OK=8191', 1)),
            ('SFP.SFP_CLK2?',       ('OK=8191', 1)),
            ('SFP.SFP_CLK3?',       ('OK=8191', 1)),
            ('SFP.LINK1_UP?',       ('OK =1', 0)),
            ('SFP.ERROR1_COUNT?',   ('OK =0', 0)),
            ('SFP.LINK2_UP?',       ('OK =1', 0)),
            ('SFP.ERROR2_COUNT?',   ('OK =0', 0)),
            ('SFP.LINK3_UP?',       ('OK =1', 0)),
            ('SFP.ERROR3_COUNT?',   ('OK =0', 0))
        ])

        for cmd, expected in internal_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))

        return not all(self.test_result)

    def check_response(self, response, expected, cmd, bnd=0):
        try:
            response_val = int(response.split('=')[1])
            expected_val = int(expected.split('=')[1])
            check = expected_val - bnd <= response_val <= expected_val + bnd
        except IndexError:
            #if the response is simply "OK"
            check = response == expected

        if check:
            self.logger.info("{:<20} [{:<9}]  ..OK".format(cmd, response))
            return 1
        else:
            self.logger.info("{:<20} [{:<9}]  ..NOT OK".format(cmd, response))
            return 0